﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using HeuristicLab.Clients.Hive.CloudManager.Model;

namespace HeuristicLab.Clients.Hive.CloudManager.Azure {
  public interface IAzureProvider {
    Subscription GetSubscriptionInfo(string subscriptionId, string thumbprint);
    List<string> ListLocations(Subscription subscription);
    List<HostedService> ListHostedServices(Subscription subscription);
    List<AffinityGroup> ListAffinityGroups(Subscription subscription);
    string CreateHostedService(Subscription subscription, string serviceName, string label, string description, AffinityGroup affinityGroup);
    string CreateHostedService(Subscription subscription, string serviceName, string label, string description, string location);
    string AddCertificate(Subscription subscription, HostedService service, string certficateFilePath, string certificatePassword);
    string CreateDeployment(Subscription subscription, string serviceName, string deploymentName, string deploymentSlot, string packageUrl, string configurationUrl, string label);
    string CreateDeployment(Subscription subscription, string serviceName, string deploymentName, string deploymentSlot, string packageUrl, string configurationUrl, string label, int instanceCount);
  }
}
